******************************************************************************
*
*	General purpose hardware startup, housekeeping and exit shell
*	Copyright (c) 1990 J.P.Garner. This source code may only be 
*	repeated in a program released into the public domain. No program
*	containing this code, or parts of this code, may be distributed or 
*	sold, as a commercial program, 	as shareware, or with a magazine or
*	in any other form. This code is not to printed without the author's
*	consent, and remains copyright (c) 1990 of the author (J.P.Garner).
*	
*	In other words.... Use it in your demos folks!
*
******************************************************************************
;
	CODE
;
;******************************************************************************;
;
start:suba.l a1,a1			;All code run from CLI or workbench
	move.l 4,a6			; enters at the start of the first code
	jsr findtask(a6)		;hunk. Your code should be just one
	move.l d0,a4			;big code hunk.
	tst.l $ac(a4)	
	bne program			;Jump if called from CLI
;
	lea $5c(a4),a0			;Hmmm, how does this work? Oh yeah,
	move.l a0,a3			;workbench sends a message when it's
	jsr waitport(a6)		;ready to start.
	move.l a3,a0
	jsr getmsg(a6)			;Guess!
	move.l d0,workbenchmessage
;
program:move #$00f,custom+$96		;kill audio
	bsr jsetcopper			;setup copper and all sorts of stuff
					;put your setup routines here.
	move #0,nextfb			;tell interrupt not to flip screens
;
jmainloop:bra checkmouse		;hmmm
maincalls:move.b #$ff,jscreen+1		;set processing flag
;
**** loop calls				;put your loop calls here
;
flipok:tst nextfb			;Kill this line if you don't want
	bne flipok			;Double buffering. And this line.
	move #1,nextfb			;And this line.
	bra jmainloop			;But not his line!
;
;---------------------------------------------------------------------------;
;
checkmouse:btst #10,$dff016		;This single steps on clicks of Right
	bne waitrm			;mouse. Runs full speed when you
	andi.b #$40,$bfe001		;hold down Right and left mouse.
	beq waitgoloop			;quits on left.
	bra checkmouse			;kill this line to auto run.
;
waitrm:	andi.b #$40,$bfe001
	beq quit
	btst #10,$dff016
	bne waitrm			;kill this line to auto run.
;
waitgoloop:move.l #0,d0			;Change this number to slow loop
goloop:tst.b jscreen+1			;(currently runs at 50 frames
	bne goloop			; a second)
	move.b #$ff,jscreen+1		;This flag is set to zer0 every
	dbf d0,goloop			;frame fly
	bra maincalls
;
******************************************************************************
*****************************************************************************
**
**		Setup routines
**
******************************************************************************
******************************************************************************
;
panik:move.l #$f0f0,d1
	bra libstop
jsetcopper:move.l execbase,a6
;
	lea dosname,a1			; open library
	moveq #0,d0
	jsr openlib(a6)
	tst.l d0
	beq panik
	move.l d0,dosbase
;
	move.l 4,a6			;trackdisc device handler
	lea diskio,a1
	lea trddevice,a0
	moveq #0,d0
	moveq #0,d1
	move.l #diskrep,14(a1)
	jsr opendevice(a6)
;
	move #9,28(a1)			;switch off motor
	move #0,36(a1)
	jsr sendio(a6)
;
	move.l dosbase,a1		;close library
	jsr LVOcloselib(a6)
;
	lea diskio,a1			;close trackdisc
	jsr closedevice(a6)
;
	lea gfxname,a1			;openlibrary to get copper 
	moveq #0,d0
	jsr openlib(a6)
	tst.l d0
	beq panik
	move.l d0,gfxbase
;
	move.l d0,a0
	move.l $32(a0),oldcopper	;nick the copper
	move.l execbase,a6
	jsr LVOforbid(a6)
	tst.l d0
	beq panik
;
	moveq #7,d0			;wipe out and disable sprites
	lea $140+custom,a0
killspriteloop:move #0,4(a0)
	move #0,6(a0)
	move #0,0(a0)
	move #0,2(a0)
	adda.l #8,a0
	dbf d0,killspriteloop
	move #$0020,dmacon+custom
;
;------------------------------------------------------------------------------;
;
	lea jcolours1(pc),a0				;colourtable
	bsr jsetcolours
;
;------------------------------------------------------------------------------;
;
jscsetdma:lea jbp1,a1			;setup screen
	bsr putplanes
	lea jbp1,a0
	move.l a0,displayscreen		;setup screen pointers
	lea jbp11,a0
	move.l a0,drawscreen
;
;------------------------------------------------------------------------------;
;
copdone:lea custom,a2
	move.w #%0000000110000000,dmacon(a2)
;
	lea jcoppertable(pc),a1		;install our coppertable
	move.l gfxbase,a0
	move.l #jcoppertable,$32(a0)
;
	move.w #%1000000110000000,dmacon(a2)
;
	move #$8010,$dff09a		;enable copper interrupts
	move.l $6c.w,oldcopintr
	move.l #jcopintr,$6c.w
;
jscwaitvb:lea custom,a2			;if you want to wait for
	move.w vhposr(a2),d0		;a 200 line screen frame fly
	and.l #$0000ff00,d0
	cmp.w #$ff00,d0
	bne jscwaitvb
	rts
;
jcopintr:movem.l d0-d7/a0-a6,-(sp)
	and.w #$10,$dff01e
	beq outintr			;jump to system housekeeping
	move.w #$10,$dff09c		;clear interrupt-it's ours
	eor.b #$ff,jscreen		;toggle- some people find this
	move.b #$00,jscreen+1		;usefull. Clear this flag
;
	tst nextfb			;check flip screen flag. If you don't
	beq outintr			;want double buffering then never set
;					;this flag.
	move.l drawscreen,a1		;swap screens
	move.l displayscreen,drawscreen
	move.l a1,displayscreen
;
	bsr putplanes
	move #0,nextfb			;signal swapped
	bra outintr
;
	even
outintr:movem.l (sp)+,d0-d7/a0-a6
	dc.w $4ef9			;code for jmp
oldcopintr:dc.l 0
;
putplanes:move.l #$e2,d1		;setup bitplanes-----16 colour
	lea jcoppertable(pc),a0
	moveq #3,d0			;set this to number of bitplanes-1
pploop1:move.l a1,d2
	move d1,(a0)+
	move d2,(a0)+
	swap d2
	subq #2,d1
	move d1,(a0)+
	move d2,(a0)+
	addq #6,d1
	adda.l #10240,a1
	dbf d0,pploop1
	rts
;
jsetcolours:lea jcopcolors,a1
	move.l #$180,d0
jcolloop:move.w d0,(a1)+
	move.w (a0)+,(a1)+
	addq #2,d0
	cmp #$1c0,d0
	bne jcolloop
	rts
;
*****************************************************************************
*****************************************************************************
**
**		Main loop codes.....
**
*****************************************************************************
*****************************************************************************
*
;
*put you main loop subroutines here
;
*
******************************************************************************
;
quit:	movem.l d0-d7/a0-a6,-(sp)	;debug aid
;
	lea custom,a2
	move.l gfxbase,a0
	move.l oldcopper,d0
	move.w #$008f,dmacon(a2)	;kill audio and copper dma
	move.l d0,$32(a0)
	move.l oldcopintr,$6c.w
	move.w #$80a0,dmacon(a2)	;copper back on
;
quit2:move.l execbase,a6		;wipe out graphics library
	move.l gfxbase,a1
	jsr LVOcloselib(a6)
	move.l execbase,a6
	jsr permit(a6)			;switch multitasking back on
;
	movem.l (sp)+,d0-d7/a0-a6
;
	tst.l workbenchmessage
	bne endtowb
	moveq #0,d0			;signal a-ok
	rts
;
endtowb:move.l 4,a6			
	jsr LVOforbid(a6)		;don't ask me why-you need to do it!
	move.l workbenchmessage,a1	;tell workbench that it's all over
	jsr replymsg(a6)		;and you're leaving
	moveq #0,d0
	rts
;
libstop:movem.l d0-d7/a0-a6,-(sp)
	bra quit2
;
;******************************************************************************;
;
jcolours1:dc.w $000,$111,$222,$333,$444,$555,$666,$777
	dc.w $888,$999,$aaa,$bbb,$ccc,$ddd,$eee,$fff
	dc.w $000,$040,$0f0,$0f0,$fff,$fff,$fff,$fff
	dc.w $fff,$fff,$fff,$fff,$fff,$fff,$fff,$fff
;
jcoppertable:blk.l 8,0			;number of bitplanes*2
	dc.w dmacon,$0000
	dc.w bpl1mod,0,bpl2mod,0
	dc.w bplcon0,$4000		;number of bit planes*4096
	dc.w bplcon1,0
	dc.w bplcon2,%0000000000100000
	dc.w ddfstrt,$38,ddfstop,$d0
	dc.w diwstrt,$2c81,diwstop,$2cc1
jcopcolors:blk.l 32,0
	even
jbarcoppertable:
	dc.w $ff29,$fffe,$2c29,$fffe,$009c,$8010,$ffff,$fffe,$ffff,$fffe
;
jscreen:dc.b 0,0
displayscreen:dc.l 0
drawscreen:dc.l 0
nextfb:dc.w 0
;
workbenchmessage:dc.l 0
gfxbase:dc.l	0
dosbase:dc.l	0
oldcopper:dc.l	0
diskio:blk.l	20,0
diskrep:blk.l	8,0
;
gfxname:dc.b	"graphics.library",0
	even
dosname:dc.b	"dos.library",0
	even
trddevice:dc.b	"trackdisk.device",0
	even
;*****************************************************************************;
;
execbase:		equ	4
openlib:		equ	-408
LVOcloselib:		equ	-414
LVOforbid:			equ	-132
permit:			equ	-138
opendevice:		equ	-444
closedevice:		equ	-450
sendio:			equ	-462
findtask:		equ	-294
waitport:		equ	-384
getmsg:			equ	-372
replymsg:		equ	-378
AllocMem:		equ	-198
FreeMem:		equ	-210
;
;*****************************************************************************;
;
jbp1:blk.b 10240,0		;bitplanes
jbp2:blk.b 10240,0
jbp3:blk.b 10240,0
jbp4:blk.b 10240,0
;
jbp11:blk.b 10240,0		;set these lines to 0 block size if you
jbp12:blk.b 10240,0		;want single buffering
jbp13:blk.b 10240,0
jbp14:blk.b 10240,0
;
;******************************************************************************;
;
custom:		equ	$dff000	;The complete hardware register list
;
bltddat:	equ	$0	;type these in as you need them!
dmaconr:	equ	$2
vposr:		equ 	$4
vhposr:		equ	$6
dskdatr:	equ	$8
joy0dat:	equ	$a
joy1dat:	equ	$c
clxdat:		equ	$e
adkconr:	equ	$10
pot0dat:	equ	$12
pot1dat:	equ	$14
potgor:		equ	$16
serdata:	equ	$18
dskbytr:	equ	$1a
intenar:	equ	$1c
intreqr:	equ	$1e
dskpth:		equ	$20
dskptl:		equ	$22
dsklen:		equ	$24
dskdat:		equ	$26
refptr:		equ	$28
vposw:		equ	$2a
vhposw:		equ	$2c
copcon:		equ	$2e
serdat:		equ	$30
serper:		equ	$32
potgo:		equ	$34
joytest:	equ	$36
strequ:		equ	$38
strvbl:		equ	$3a
strhor:		equ	$3c
strlong:	equ	$3e
bltcon0:	equ	$40
bltcon1:	equ	$42
bltafwm:	equ	$44
bltalwm:	equ	$46
bltcpth:	equ	$48
bltcptl:	equ	$4a
bltbpth:	equ	$4c
bltbptl:	equ	$4e
bltapth:	equ	$50
bltaptl:	equ	$52
bltdpth:	equ	$54
bltdptl:	equ	$56
bltsize:	equ	$58
bltcmod:	equ	$60
bltbmod:	equ	$62
bltamod:	equ	$64
bltdmod:	equ	$66
bltcdat:	equ	$70
bltbdat:	equ	$72
bltadat:	equ	$74
dsksync:	equ	$7e
cop1lch:	equ	$80
cop1lcl:	equ	$82
cop2lch:	equ	$84
cop2lcl:	equ	$86
copjmp1:	equ	$88
copjmp2:	equ	$8a
copins:		equ	$8c
diwstrt:	equ	$8e
diwstop:	equ	$90
ddfstrt:	equ	$92
ddfstop:	equ	$94
dmacon:		equ	$96
clxcon:		equ	$98
intena:		equ	$9a
intreq:		equ	$9c
adkcon:		equ	$9e
;
aud0lch:	equ	$a0
aud0lcl:	equ	$a2
aud0len:	equ	$a4
aud0per:	equ	$a6
aud0vol:	equ	$a8
aud0dat:	equ	$aa
;
aud1lch:	equ	$b0
aud1lcl:	equ	$b2
aud1len:	equ	$b4
aud1per:	equ	$b6
aud1vol:	equ	$b8
aud1dat:	equ	$ba
;
aud2lch:	equ	$c0
aud2lcl:	equ	$c2
aud2len:	equ	$c4
aud2per:	equ	$c6
aud2vol:	equ	$c8
aud2dat:	equ	$ca
;
aud3lch:	equ	$d0
aud3lcl:	equ	$d2
aud3len:	equ	$d4
aud3per:	equ	$d6
aud3vol:	equ	$d8
aud3dat:	equ	$da
;
bpl1pth:	equ	$e0
bpl1ptl:	equ	$e2
bpl2pth:	equ	$e4
bpl2ptl:	equ	$e6
bpl3pth:	equ	$e8
bpl3ptl:	equ	$ea
bpl4pth:	equ	$ec
bpl4ptl:	equ	$ee
bpl5pth:	equ	$f0
bpl5ptl:	equ	$f2
bpl6pth:	equ	$f4
bpl6ptl:	equ	$f6
;
bplcon0:	equ	$100	
bplcon1:	equ	$102
bplcon2:	equ 	$104
bpl1mod:	equ	$108
bpl2mod:	equ	$10a
;
bpl1dat:	equ	$110
bpl2dat:	equ	$112
bpl3dat:	equ	$114
bpl4dat:	equ	$116
bpl5dat:	equ	$118
bpl6dat:	equ	$11a
;
spr0pth:	equ	$120
spr0ptl:	equ	$122
spr1pth:	equ	$124
spr1ptl:	equ	$126
spr2pth:	equ	$128
spr2ptl:	equ	$12a
spr3pth:	equ	$12c
spr3ptl:	equ	$12e
spr4pth:	equ	$130
spr4ptl:	equ	$132
spr5pth:	equ	$134
spr5ptl:	equ	$136
spr6pth:	equ	$138
spr6ptl:	equ	$13a
spr7pth:	equ	$13c
spr7ptl:	equ	$13e
;
spr0pos:	equ	$140
spr0ctl:	equ	$142
spr0data:	equ	$144
spr0datb:	equ	$146
;
spr1pos:	equ	$148
spr1ctl:	equ	$14a
spr1data:	equ	$14c
spr1datb:	equ	$14e
;
spr2pos:	equ	$150
spr2ctl:	equ	$152
spr2data:	equ	$154
spr2datb:	equ	$156
;
spr3pos:	equ	$158
spr3ctl:	equ	$15a
spr3data:	equ	$15c
spr3datb:	equ	$15e
;
spr4pos:	equ	$160
spr4ctl:	equ	$162
spr4data:	equ	$164
spr4datb:	equ	$166
;
spr5pos:	equ	$168
spr5ctl:	equ	$16a
spr5data:	equ	$16c
spr5datb:	equ	$16e
;
spr6pos:	equ	$170
spr6ctl:	equ	$172
spr6data:	equ	$174
spr6datb:	equ	$176
;
spr7pos:	equ	$178
spr7ctl:	equ	$17a
spr7data:	equ	$17c
spr7datb:	equ	$17e
;
colour0:	equ	$180
colour1:	equ	$182
colour2:	equ	$184
colour3:	equ	$186
colour4:	equ	$188
colour5:	equ	$18a
colour6:	equ	$18c
colour7:	equ	$18e
colour8:	equ	$190
colour9:	equ	$192
colour10:	equ	$194
colour11:	equ	$196
colour12:	equ	$198
colour13:	equ	$19a
colour14:	equ	$19c
colour15:	equ	$19e
colour16:	equ	$1a0
colour17:	equ	$1a2
colour18:	equ	$1a4
colour19:	equ	$1a6
colour20:	equ	$1a8
colour21:	equ	$1aa
colour22:	equ	$1ac
colour23:	equ	$1ae
colour24:	equ	$1b0
colour25:	equ	$1b2
colour26:	equ	$1b4
colour27:	equ	$1b6
colour28:	equ	$1b8
colour29:	equ	$1ba
colour30:	equ	$1bc
colour31:	equ	$1be
;
;***************************************************************************;
