***************************************************************************
*
* Copyright (c) 1990 JP Garner. This source code may only be repeated in a
* program released into the public domain. No program containing this code,
* or parts of this code, may be distributed or sold as a commercial program,
* as shareware, with a magazine, or in any other form. This code is not to
* printed without the author's consent.
* In other words...
* Use it in your demos, folks!
*
* Remember this is written for Seka.
* Change BLK instructions to DS for Devpac, Argasm, etc.
*
***************************************************************************

		;Change the main shell so
		;that it looks like this...
program:	move #$00f,custom+$96
	bsr jsetbars	;Add the setup call here.
	bsr jsetcopper	;It goes before jsetcopper
		;because it alters the copper list.					

		;Change the main shell so
		;that it looks like this...
maincalls:	move.b #$ff,jscreen+1

loopcalls:	bsr jdobars	;Put the main subroutine call in here.

flipok:	tst nextfb	

***************************************************************************
* Set-up routines
***************************************************************************

jsetbars:	moveq #14,d0		;Pre-set counters and
	lea jbarcoppertable+6,a0	;stuff for main routine.
	lea jbaroldadds+60,a1
	lea jbarpos+30,a2
jsbl1:	moveq #20,d1		;One bar each 20 degrees.
	mulu d0,d1
	move.w d1,-(a2)		;Save degree position.
	move.l a0,-(a1)		;Save and address
	dbf d0,jsbl1		;to erase loop.
			;
			;Now we build up a big copper
			;table. For each line we have
			;a CWAIT and a CMOVE instruction.
			;
	lea jbarcoppertable,a0		;Points to table.
	moveq #0,d0		;Counter .w line number.
jscloop1:	move.b d0,(a0)+		;Vpos bits to high byte.
	move.b #%1,(a0)+			;Set up lower 8 bits.
	move.w #%1111111111111110,(a0)+	;Wait enable.
	move.w #$0180,(a0)+			;CMOVE. Colour00.
	move.w #$0000,(a0)+		;Set to black.
	addq #1,d0		;Next line.
	cmp #313,d0                 
	bne jscloop1		;Loop back.
	move.w #$9c,(a0)+		;Move to interupt request.
	move.w #$8010,(a0)+		;Set copper interrupt.
	move.w #$ffff,(a0)+		;Wait for the impossible.
	move.w #$fffe,(a0)+
	rts

**************************************************************************
* Main loop code
**************************************************************************

jdobars:	lea jbaroldadds,a0	;Old addresses.
	moveq #14,d0	;15 bars-1.
jdbl1:	move.l (a0)+,a2	;Load address into a2.
	moveq #6,d1	;Erase small bars.
jdbl2:	move.w #0,(a2)	;Set to black.
	add.l #8,a2	;Next line in copper list.
	dbf d1,jdbl2	;Loop for 7 lines.
	dbf d0,jdbl1	;Next bar.
	lea jbaroldadds,a0	;Old addresses.
	lea jbarpos,a1	;Degree position.
	lea jbarshades,a4	;Pointer to colour value lists.
	add.w #3,jtubepos	;"tube" rotates in 3 deg increments.
	cmp #360,jtubepos
	blt jdtnoover
	move.w #0,jtubepos
jdtnoover:	move.w jtubepos,d1	;Calculate offset in table.
	add.l d1,d1
	lea sintab,a2
	add.l d1,a2	;a2 points to right value.
	move.b (a2),d1	;64 to -64.
	ext.w d1			
	ext.l d1	;Now signed long word.
	asr.l #1,d1	;Divide by 2.
	add.l #159,d1	;Centre.
	asl.l #3,d1		;Multiply by 8 to get offset.
	lea jbarcoppertable+6,a3	;First colour00 data value.
	add.l d1,a3		;a3 points to correct.
	moveq #14,d0	;15-1 bars.
jdbl4:	moveq #0,d1	;Increment degree position.
	add.w #1,(a1)	;a1 points to table of degree
	cmp #360,(a1)	;position.
	blt jdpnoover
	move.w #0,(a1)
jdpnoover:	move.w (a1)+,d1	;Work out position.
	add.l d1,d1
	lea sintab,a2
	add.l d1,a2
	move.b (a2),d1	;64 to -64.
	ext.w d1
	ext.l d1
	muls #8,d1	;d1 has offset in copper list.
	move.l a3,a2	;a3 holds central tube address.
	add.l d1,a2	;a2 final address.
	move.l a2,(a0)+	;Save address in erase list.
	moveq #6,d1	;7-1 lines.
jdbl3:	move.w (a4)+,(a2)	;Copy colour table to list.
	add.l #8,a2	;Next line.
	dbf d1,jdbl3	;Loop back.
	dbf d0,jdbl4	;Next bar.
	rts
		;Change the main shell so
		;that it looks like this...
jbarcoppertable:
	blk.w 2*2*313
	dc.w $009c,$8010,$ffff,$fffe,$ffff,$fffe

***************************************************************************
*
* This sin table will be used over and over again. You only need type a
* quarter in, then use cut and paste and key-macros to do the rest, or make
* the table from Basic. The formula is sin(x)*16384, where x is an integer
* between 0 and 360.
*
***************************************************************************

sintab:	dc.w 0,286,572,857,1143,1428,1713,1997,2280
	dc.w 2563,2845,3126,3406,3686,3964,4240,4516
	dc.w 4790,5063,5334,5604,5872,6138,6402,6664
	dc.w 6924,7182,7438,7692,7943,8192,8438,8682	
	dc.w 8923,9162,9397,9630,9860,10087,10311,10531
	dc.w 10749,10963,11174,11381,11585,11786,11982,12176
	dc.w 12365,12551,12733,12911,13085,13255,13421,13583
	dc.w 13741,13894,14044,14189,14330,14466,14598,14726
	dc.w 14849,14968,15082,15191,15296,15396,15491,15582
	dc.w 15668,15749,15826,15897,15964,16026,16083,16135
	dc.w 16182,16225,16262,16294,16322,16344,16362,16374
	dc.w 16382,16384
	dc.w 16382,16374,16362,16344,16322,16294,16262,16225,16182
	dc.w 16135,16083,16026,15964,15897,15826,15749,15668	
	dc.w 15582,15491,15396,15296,15191,15082,14967,14849
	dc.w 14726,14598,14466,14330,14189,14044,13894,13741	
	dc.w 13583,13421,13255,13085,12911,12733,12551,12365
	dc.w 12176,11982,11786,11585,11381,11174,10963,10749
	dc.w 10531,10311,10087,9860,9630,9397,9162,8923
	dc.w 8682,8438,8192,7943,7692,7438,7182,6924
	dc.w 6664,6402,6138,5872,5604,5334,5063,4790
	dc.w 4516,4240,3964,3686,3406,3126,2845,2563
	dc.w 2280,1997,1713,1428,1143,857,572,286,0

	dc.w -286,-572,-857,-1143,-1428,-1713,-1997,-2280
	dc.w -2563,-2845,-3126,-3406,-3686,-3964,-4240,-4516
	dc.w -4790,-5063,-5334,-5604,-5872,-6138,-6402,-6664
	dc.w -6924,-7182,-7438,-7692,-7943,-8192,-8438,-8682	
	dc.w -8923,-9162,-9397,-9630,-9860,-10087,-10311,-10531
	dc.w -10749,-10963,-11174,-11381,-11585,-11786,-11982,-12176
	dc.w -12365,-12551,-12733,-12911,-13085,-13255,-13421,-13583
	dc.w -13741,-13894,-14044,-14189,-14330,-14466,-14598,-14726
	dc.w -14849,-14968,-15082,-15191,-15296,-15396,-15491,-15582
	dc.w -15668,-15749,-15826,-15897,-15964,-16026,-16083,-16135
	dc.w -16182,-16225,-16262,-16294,-16322,-16344,-16362,-16374
	dc.w -16382,-16384,-16382
	dc.w -16374,-16362,-16344,-16322,-16294,-16262,-16225,-16182
	dc.w -16135,-16083,-16026,-15964,-15897,-15826,-15749,-15668	
	dc.w -15582,-15491,-15396,-15296,-15191,-15082,-14967,-14849
	dc.w -14726,-14598,-14466,-14330,-14189,-14044,-13894,-13741	
	dc.w -13583,-13421,-13255,-13085,-12911,-12733,-12551,-12365
	dc.w -12176,-11982,-11786,-11585,-11381,-11174,-10963,-10749
	dc.w -10531,-10311,-10087,-9860,-9630,-9397,-9162,-8923
	dc.w -8682,-8438,-8192,-7943,-7692,-7438,-7182,-6924
	dc.w -6664,-6402,-6138,-5872,-5604,-5334,-5063,-4790
	dc.w -4516,-4240,-3964,-3686,-3406,-3126,-2845,-2563
	dc.w -2280,-1997,-1713,-1428,-1143,-857,-572,-286,-0

jtubepos:	dc.w 0
jbarpos:	blk.w 15,0
jbaroldadds:blk.l 15,0

jbarshades:	dc.w $300,$700,$b00,$e00,$b00,$700,$300
	dc.w $310,$710,$b20,$e20,$b20,$710,$310
	dc.w $310,$720,$b30,$e40,$b30,$720,$310
	dc.w $320,$730,$b50,$e60,$b50,$730,$320

	dc.w $320,$740,$b60,$e80,$b60,$740,$320
	dc.w $320,$750,$b80,$ea0,$b80,$750,$320
	dc.w $330,$760,$ba0,$ec0,$ba0,$760,$330
	dc.w $330,$770,$bb0,$ee0,$bb0,$770,$330

	dc.w $330,$670,$ab0,$ce0,$ab0,$670,$330
	dc.w $230,$570,$8b0,$ae0,$8b0,$570,$230
	dc.w $230,$470,$6b0,$8e0,$6b0,$470,$230
	dc.w $230,$370,$5b0,$6e0,$5b0,$370,$230

	dc.w $130,$270,$3b0,$4e0,$3b0,$270,$130
	dc.w $130,$170,$2b0,$2e0,$2b0,$170,$130
	dc.w $030,$070,$0b0,$0e0,$0b0,$070,$030
