******************************************************************************
*
*	Copyright (c) 1990 J.P.Garner. This source code may only be 
*	repeated in a program released into the public domain. No program
*	containing this code, or parts of this code, may be distributed or 
*	sold, as a commercial program, 	as shareware, or with a magazine or
*	in any other form. This code is not to printed without the author's
*	consent, and remains copyright (c) 1990 of the author (J.P.Garner).
*	
*	In other words.... Use it in your demos folks!
*
******************************************************************************
;
					;change the basic setup to look
					;like this....
					;
program:move #$00f,custom+$96
	bsr jsetwibble			;sets up copperlist so goes before
	bsr jsetcopper			;JSETCOPPER
;
	move #0,nextfb			;tell interrupt not to flip screens
;
jmainloop:bra checkmouse
maincalls:move.b #$ff,jscreen+1
;
loopcalls:bsr jdowibble			;alter copperlist
	bsr jmakewibble			;calculate next frame
;
******************************************************************************
*****************************************************************************
**
**		Setup routines
**
******************************************************************************
******************************************************************************
;
jsetwibble:move #$ff,d0				;256 lines to the screen
	moveq #0,d1				;quicker than clr opcode
	lea jwibbletable,a0
jswloop:move d1,(a0)+
	addq #1,d1				;just set to normal screen
	dbf d0,jswloop
;
	lea endsmallsintab,a0			;to save you typing, and so
	lea endbigsintab,a1			;the routine runs faster.
	tst.l -8(a1)
	bne jswtabledone
	move #359,d0				;this multiplies the sintab
jswloop2:move.w -(a0),d1			;by four and saves it as a
	muls #4,d1				;longword. So you start at the
	move.l d1,-(a1)				;end to avoid corrupting your
	dbf d0,jswloop2				;own data
;
;					Now we build up a big
;					coppertable. For each line we have
;					a CWAIT and a CMOVE instruction.
;					This is very similar to the copper
;					bars.
;
;
jswtabledone:lea jbarcoppertable,a0			;points to table
	moveq #$2b,d0				;counter .w line number
jscloop1:move.b d0,(a0)+			;vpos bits to high byte
;
	move.b #$e1,(a0)+			;this is different to copper bars
;
	move.w #%1111111111111110,(a0)+		;wait enable
;
	move.w #$0108,(a0)+			;CMOVE. bpl1mod
	move.w #$0000,(a0)+			;set to next line
;
	move.w #$010a,(a0)+			;CMOVE. bpl2mod
	move.w #$0000,(a0)+			;set to next line
;
	addq #1,d0				;next line
	cmp #300,d0
	bne jscloop1				;loop
;
	move.w #$9c,(a0)+			;Move to interupt request
	move.w #$8010,(a0)+			;set copper interrupt
	move.w #$ffff,(a0)+			;wait for impossible
	move.w #$fffe,(a0)+
	rts
;
*****************************************************************************
*****************************************************************************
**
**		Main loop codes.....
**
*****************************************************************************
*****************************************************************************
*
;						 This takes the data in 
;						 JWIBBLETABLE and alters the
;						 modulos in the copper list.
jdowibble:tst.l lastline
	beq jwtablemade				;jump if a table hasn't
	move.l lastline,a0			;been written. Erase old stop
	lea jbarcoppertableend,a1		;check in a-ok place
	cmp.l a0,a1
	bcs jwtablemade
	move.l #$1080000,(a0)			;delete old stop
;
jwtablemade:lea jwibbletable,a0			;list of bit plane lines
	moveq #0,d0
	lea jbarcoppertable+6,a1
jdwloop1:move (a0)+,d1				;this line
	move (a0),d2				;next line
	sub d1,d2				;lines between this line &
	sub #1,d2				;next. You always go down 1
	muls #40,d2				;so account for it. 40 bytes
						;per line. d2 holds modulo
;
	move d2,(a1)				;set bpl1mod
	move d2,4(a1)				;set bpl2mod
	adda.l #12,a1				;next line in table
	tst.b (a0)				;MSB 0 if line<256
	bne endofscreen				;jump if whole screen visible
;
	add #1,d0
	cmp #255,d0
	bcs jdwloop1
;
endofscreen:suba.l #12+2,a1			;last line CMOVE
	move.l a1,lastline			;save it
	lea jbarcoppertableend,a2		;check in a-ok place
	cmp.l a1,a2
	bcs jdwend
	move.l #$01000000,(a1)			;set bplcon0 to 0. Switches
jdwend:rts					;off screen
;
******************************************************************************
;
jmakewibble:lea jwibbletable,a0			;table of line numbers
	move #255,d0				;256 lines
	move wibbleat,d1			;degree counter
	moveq #0,d2				;set it to 0
	add speed,d1				;next degree
	cmp #360,d1	
	bcs jmwnoover
	sub #360,d1
jmwnoover:move d1,wibbleat
jmwloop:move size,d5
jmwloop2:move d1,d3				;degree to work
	ext.l d3				;long cos it's an offset
	asl.l #2,d3				;longwords
	lea sintab,a1
	adda.l d3,a1				;a1 points to right sin entry
	move.l #$10000,d4			
	add.l (a1),d4				;0 to $20000
	add.l d4,d2				;d2 is counter
;
	add lens,d1				;next degree
	cmp #360,d1	
	bcs jmwnoover2
	sub #360,d1
;
jmwnoover2:dbf d5,jmwloop2			;loop for size
;
	swap d2
	move d2,(a0)+
	swap d2
;
	dbf d0,jmwloop				;next line
	rts	
;
*
******************************************************************************
;
;				Change the basic source to look like this
;
jcolours1:dc.w $000,$888,$444,$ccc,$222,$aaa,$666,$eee	;this just happens
	dc.w $111,$999,$555,$ddd,$333,$bbb,$777,$fff	;to be the colours i
	dc.w $000,$040,$0f0,$0f0,$fff,$fff,$fff,$fff	;need for my digi-pic
	dc.w $fff,$fff,$fff,$fff,$fff,$fff,$fff,$fff	;set these to
							;whatever you need.
;
jbarcoppertable:blk.w 2*2*2*313	;This is different from the copper bars!
jbarcoppertableend:dc.w $009c,$8010,$ffff,$fffe,$ffff,$fffe
;
;******************************************************************************;
;
;	This is just the same as the sintable last month, so if you've typed it
;	in once, then there's no need to do it again.
;
;	This sintable will be used over and over again. You only need
;	type a quarter in, then use cut and paste and key-macros to do
;	the rest, or make the table from BASIC. The formula is sin(x)*16384
;	where x is an integer between 0 and 360.
;
sintab:	dc.w 0,286,572,857,1143,1428,1713,1997,2280
	dc.w 2563,2845,3126,3406,3686,3964,4240,4516
	dc.w 4790,5063,5334,5604,5872,6138,6402,6664
	dc.w 6924,7182,7438,7692,7943,8192,8438,8682	
	dc.w 8923,9162,9397,9630,9860,10087,10311,10531
	dc.w 10749,10963,11174,11381,11585,11786,11982,12176
	dc.w 12365,12551,12733,12911,13085,13255,13421,13583
	dc.w 13741,13894,14044,14189,14330,14466,14598,14726
	dc.w 14849,14968,15082,15191,15296,15396,15491,15582
	dc.w 15668,15749,15826,15897,15964,16026,16083,16135
	dc.w 16182,16225,16262,16294,16322,16344,16362,16374
	dc.w 16382,16384
	dc.w 16382,16374,16362,16344,16322,16294,16262,16225,16182
	dc.w 16135,16083,16026,15964,15897,15826,15749,15668	
	dc.w 15582,15491,15396,15296,15191,15082,14967,14849
	dc.w 14726,14598,14466,14330,14189,14044,13894,13741	
	dc.w 13583,13421,13255,13085,12911,12733,12551,12365
	dc.w 12176,11982,11786,11585,11381,11174,10963,10749
	dc.w 10531,10311,10087,9860,9630,9397,9162,8923
	dc.w 8682,8438,8192,7943,7692,7438,7182,6924
	dc.w 6664,6402,6138,5872,5604,5334,5063,4790
	dc.w 4516,4240,3964,3686,3406,3126,2845,2563
	dc.w 2280,1997,1713,1428,1143,857,572,286,0
;
	dc.w -286,-572,-857,-1143,-1428,-1713,-1997,-2280
	dc.w -2563,-2845,-3126,-3406,-3686,-3964,-4240,-4516
	dc.w -4790,-5063,-5334,-5604,-5872,-6138,-6402,-6664
	dc.w -6924,-7182,-7438,-7692,-7943,-8192,-8438,-8682	
	dc.w -8923,-9162,-9397,-9630,-9860,-10087,-10311,-10531
	dc.w -10749,-10963,-11174,-11381,-11585,-11786,-11982,-12176
	dc.w -12365,-12551,-12733,-12911,-13085,-13255,-13421,-13583
	dc.w -13741,-13894,-14044,-14189,-14330,-14466,-14598,-14726
	dc.w -14849,-14968,-15082,-15191,-15296,-15396,-15491,-15582
	dc.w -15668,-15749,-15826,-15897,-15964,-16026,-16083,-16135
	dc.w -16182,-16225,-16262,-16294,-16322,-16344,-16362,-16374
	dc.w -16382,-16384,-16382
	dc.w -16374,-16362,-16344,-16322,-16294,-16262,-16225,-16182
	dc.w -16135,-16083,-16026,-15964,-15897,-15826,-15749,-15668	
	dc.w -15582,-15491,-15396,-15296,-15191,-15082,-14967,-14849
	dc.w -14726,-14598,-14466,-14330,-14189,-14044,-13894,-13741	
	dc.w -13583,-13421,-13255,-13085,-12911,-12733,-12551,-12365
	dc.w -12176,-11982,-11786,-11585,-11381,-11174,-10963,-10749
	dc.w -10531,-10311,-10087,-9860,-9630,-9397,-9162,-8923
	dc.w -8682,-8438,-8192,-7943,-7692,-7438,-7182,-6924
	dc.w -6664,-6402,-6138,-5872,-5604,-5334,-5063,-4790
	dc.w -4516,-4240,-3964,-3686,-3406,-3126,-2845,-2563
	dc.w -2280,-1997,-1713,-1428,-1143,-857,-572,-286
;
;
;					The following is different from
;					the copper bars.
;
;
endsmallsintab:blk.w 360,0
endbigsintab:dc.l 0
;
jwibbletable:blk.w 256,0
lastline:dc.l 0
wibbleat:dc.w 0
;
lens:dc.w 1				;smaller value, larger wave.
speed:dc.w 2				;degree increment each frame.
size:dc.w 0				;smaller value, bigger pic.
;
;*****************************************************************************;
